#!/usr/bin/perl

for $type ("hebbian", "multifractal") {

    @avgDiff = ();
    @devDiff = ();
    for ($i=0; $i<50; ++$i) {
        push @avgDiff, 0.0;
        push @devDiff, 0.0;
    }

    for $seed (1..30) {

        @base = ();
        open BASE, "<trainingError_base_$seed.txt";
        while (<BASE>) {
            chomp;
            $_ =~ s/.*? (.*?) .*/$1/g;
            push @base, $_;
        }
        close(BASE);

        open FILE, "<trainingError_${type}_${seed}.txt";
        open RESULT, ">trainingDiff_${type}_${seed}.txt";
        $i = 0;
        while (<FILE>) {
            chomp;
            $_ =~ s/.*? (.*?) .*/$1/g;
            $diff = $base[$i] - $_;
            $avgDiff[$i] += $diff;
            $devDiff[$i] += $diff * $diff;
            $i++;
            print RESULT "$i $diff\n";
        }
        close(FILE);
        close(RESULT);

    }

    open RESULT, ">trainingDiffStat_${type}.txt";
    for ($i = 0; $i<=$#avgDiff; $i++) {
        $avgDiff[$i] /= 30.0;
        $devDiff[$i] = sqrt(($devDiff[$i] / 30.0) - ($avgDiff[$i] * $avgDiff[$i]));
        print RESULT ($i+1)." $avgDiff[$i] $devDiff[$i]\n";
    }
    close(RESULT);

}