#!/usr/bin/perl

for $type ("hebbian", "multifractal") {

    @avgDiff = ();
    @devDiff = ();
    for ($i=0; $i<50; ++$i) {
        push @avgDiff, 0.0;
        push @devDiff, 0.0;
    }

    for $seed (1, 2, 3, 4, 5, 6, 7, 8, 9, 102, 201, 202, 305, 501, 502, 507, 508, 603, 604, 607, 609, 610, 705, 706, 709, 710, 711, 712, 3374, 6988) {

        @base = ();
        open BASE, "<trainingError_base_data_$seed.txt";
        while (<BASE>) {
            chomp;
            $_ =~ s/.*? (.*?) .*/$1/g;
            push @base, $_;
        }
        close(BASE);

        open FILE, "<trainingError_${type}_data_${seed}.txt";
        open RESULT, ">trainingDiff_${type}_data_${seed}.txt";
        $i = 0;
        while (<FILE>) {
            chomp;
            $_ =~ s/.*? (.*?) .*/$1/g;
            $diff = $base[$i] - $_;
            $avgDiff[$i] += $diff;
            $devDiff[$i] += $diff * $diff;
            $i++;
            print RESULT "$i $diff\n";
        }
        close(FILE);
        close(RESULT);

    }

    open RESULT, ">trainingDiffStat_${type}_data.txt";
    for ($i = 0; $i<=$#avgDiff; $i++) {
        $avgDiff[$i] /= 30.0;
        $devDiff[$i] = sqrt(($devDiff[$i] / 30.0) - ($avgDiff[$i] * $avgDiff[$i]));
        print RESULT ($i+1)." $avgDiff[$i] $devDiff[$i]\n";
    }
    close(RESULT);

}
