/***************************************************************************
                          amygdalaclass.cpp  -  description
                             -------------------
    begin                : Wed Jul 2 2003
    copyright            : (C) 2003 by Matt Grover
    email                : mgrover@amygdala.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "amygdalaclass.h"

using namespace Amygdala;

AmygdalaClass::~AmygdalaClass()
{
}

std::string AmygdalaClass::GetClassName(bool fullyQualified)
{
    int status;
    char* demangledName;
    const std::type_info &ti = typeid(*this);

    demangledName = abi::__cxa_demangle(ti.name(), 0, 0, &status);
    std::string dn = demangledName;
    free(demangledName);

    if(!fullyQualified){ // Strip namespace prefixes such as Amygdala::
        std::string::size_type pos = dn.rfind("::");
        if(pos != std::string::npos)
            return dn.substr(pos+2);
    }

    return dn;
}

