/***************************************************************************
                           basicspikeoutput.cpp  -  description
                             -------------------
    begin                : Tue Aug 7 2001
    copyright            : (C) 2001 by Matt Grover
    email                : mgrover@amygdala.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <iostream>
#include "basicspikeoutput.h"
#include "network.h"
#include "neuron.h"

using namespace std;
using namespace Amygdala;

BasicSpikeOutput::BasicSpikeOutput():SpikeOutput(), logging(false)
{
}

BasicSpikeOutput::~BasicSpikeOutput()
{
}

void BasicSpikeOutput::OutputEvent(Neuron* nrn, AmTimeInt outputTime)
{
    if(logging) {
        Log(nrn, outputTime);
    }
    else {
        cout << "spike -- neuron " << nrn->GetId() << " at " << (outputTime/1000) << "ms" << endl;
    }
}
	
void BasicSpikeOutput::OutputCache()
{
    // nothing to do yet
}

void BasicSpikeOutput::LogSpikeTimes(string filename, AmTimeInt start, AmTimeInt end){
    logFd = fopen(filename.c_str(), "w");
    if(!logFd) throw "Canot open file: " + filename;
    logging = true;
    logStart = start;
    logEnd   = end;
}


void BasicSpikeOutput::Log(Neuron* nrn, AmTimeInt eventTime){
    if(eventTime > logEnd){
        fclose(logFd);
        logging = false;
        return;
    }
    
    fprintf(logFd, "%ld %ld\n", eventTime/1000, nrn->GetId());
}

void BasicSpikeOutput::CloseLog(){
    if(logFd && logging) fclose(logFd);
    logging = false;
    logFd = NULL;
}
