/***************************************************************************
                          inputneuron.cpp  -  description
                             -------------------
    copyright            : (C) 2004 by Matt Grover
    email                : mgrover@amygdala.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "inputneuron.h"
#include "inputneuronproperties.h"
#include "axon.h"
#include "logging.h"

using namespace Amygdala;

InputNeuron::InputNeuron(AmIdInt neuronId, const InputNeuronProperties& neuronProps):
    Neuron(neuronId, neuronProps)
{
}

InputNeuron::~InputNeuron()
{
}

void InputNeuron::SendInputSpike(AmTimeInt& now)
{
        LOGGER(5, "Neuron " << nId << " spiking!")
        LOGGER(6, "Calling Network::ScheduleSpikeDelay() -- size " << axon->size() << " -- Neuron " << nId);
        
        Network::GetNetworkRef()->ScheduleSpikeDelay(axon);
        
        spikeTime = now;
        
        if (outputGroupIdx & outputMode) {
	        OutputManager::SendOutput(this, now);
        }        
}
