/***************************************************************************
                          inputneuron.h  -  description
                             -------------------
    copyright            : (C) 2003 by Matt Grover
    email                : mgrover@amygdala.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef INPUTNEURON_H
#define INPUTNEURON_H

#include <amygdala/neuron.h>
#include <amygdala/network.h>
#include <amygdala/factory.h>
#include <amygdala/inputneuronproperties.h>

namespace Amygdala {

/** class InputNeuron */

class InputNeuron : public Neuron
{
public:
    typedef NeuronFactory<InputNeuron,InputNeuronProperties> Factory;
    virtual ~InputNeuron();

private:
    InputNeuron(AmIdInt neuronId,
                const InputNeuronProperties& neuronProps);
    
    /** */
    void SendInputSpike(AmTimeInt& now);

    friend void Network::TimeStep();

    template<class neuron, class neuronProperties>
    friend class NeuronFactory;
};

namespace Factory {
    static InputNeuron::Factory MakeInputNeuron;
}
}   // namespace Amygdala
#endif // INPUTNEURON_H
