/***************************************************************************
                          inputneuronproperties.cpp  -  description
                             -------------------
    copyright            : (C) 2004 by Matt Grover
    email                : mgrover@amygdala.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream>
#include "inputneuron.h"
#include "physicalproperties.h"
#include "logging.h"

using namespace std;
using namespace Amygdala;

InputNeuronProperties::InputNeuronProperties():NeuronProperties()
{
}

InputNeuronProperties::InputNeuronProperties(const InputNeuronProperties& rhs):
    NeuronProperties(rhs)
{
}

InputNeuronProperties::InputNeuronProperties(bool initializePhysicalProps):
    NeuronProperties(initializePhysicalProps)
{
    if(initializePhysicalProps){
        PhysicalProperties::RGB color = {255, 33, 155};
        physProps->SetBodyColor(color);
    }
}

InputNeuronProperties::~InputNeuronProperties()
{
}

InputNeuronProperties* InputNeuronProperties::Copy() const
{
    return new InputNeuronProperties(*this);
}

