/***************************************************************************
                          nconnector.cpp  -  description
                             -------------------
    begin                : Tue Feb  8 2005
    copyright            : (C) 2005 by Rudiger Koch
    email                : rkoch@amygdala.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <amygdala/nconnector.h>
#include <amygdala/synapse.h>
#include <amygdala/logging.h>

#include <iostream>

using namespace std;
using namespace Amygdala;

ConnectorRegistry ConnectorRegistry::registry;


ConnectorRegistry::ConnectorRegistry(){
    LOGGER(2, "Registering NeuronConnectors");
    connectorMap["StaticSynapse"] = new NeuronConnector <StaticSynapse, StaticSynapseProperties > ();
    connectorMap["DynamicSynapse"] = new NeuronConnector <DynamicSynapse, DynamicSynapseProperties > ();
}
NConnector * ConnectorRegistry::GetConnector(const std::string & name)
{
    return connectorMap[name];
}
void ConnectorRegistry::Register(std::string name, NConnector * connector) {connectorMap[name]=connector;}
