/***************************************************************************
                          scheduledspikeinput.h  -  description
                             -------------------
    copyright            : (C) 2004 by Matt Grover
    email                : mgrover@amygdala.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SCHEDULEDSPIKEINPUT_H
#define SCHEDULEDSPIKEINPUT_H

#include <amygdala/spikeinput.h>
#include <amygdala/factory.h>
#include <map>

namespace Amygdala {
class ScheduledSpikeInput: public SpikeInput {
public:
    typedef SpikeInputFactory<ScheduledSpikeInput> Factory;
    
    ScheduledSpikeInput(const std::string& name);
    virtual ~ScheduledSpikeInput();
    
    virtual void AddNeuron(InputNeuron* nrn);
    virtual void ReadInputBuffer();

    bool ReadSpikeList(const char* fileName);
    void ParseSpikeInput(const char *name, const char **attrs);    
    bool ReadSpikeDef(const char* fileName);
    
    void ScheduleSpike(AmIdInt nrnId, AmTimeInt spikeTime);
    void ScheduleSpike(InputNeuron* nrn, AmTimeInt spikeTime);
protected:
    ScheduledSpikeInput();
    
    std::map<AmIdInt, InputNeuron*> nrnMap;
    friend class Network;
};

namespace Factory {
    static ScheduledSpikeInput::Factory MakeScheduledSpikeInput;
}
}  // namespace Amygdala

#endif
