/***************************************************************************
                          spikeoutput.h  -  description
                             -------------------
    begin                : Tue Aug 7 2001
    copyright            : (C) 2001 by Matt Grover
    email                : mgrover@amygdala.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SPIKEOUTPUT_H
#define SPIKEOUTPUT_H

#include <amygdala/neurongroup.h>
#include <amygdala/outputmanager.h>

namespace Amygdala {
class Neuron;

/**@class SpikeOutput spikeoutput.h amygdala/spikeoutput.h
  * @see SimpleSpikeOutput
  *@author Matt Grover
  */

class SpikeOutput: public NeuronGroup {
public:
	virtual ~SpikeOutput() = 0;

	/**
	 * Raise an output event.  If output is turned on in streaming mode,
	 * this function will be called every time an output neuron spikes.
	 */
	virtual void OutputEvent(Neuron* nrn, AmTimeInt outputTime) = 0;

protected:
	SpikeOutput();
};

} // namespace Amygdala

#endif

