#include "spikingneuronproperties.h"
#include "utilities.h"

using namespace Amygdala;
using namespace Utilities;

SpikingNeuronProperties::SpikingNeuronProperties():
	NeuronProperties(),
	refPeriod(2000)
{
}

SpikingNeuronProperties::SpikingNeuronProperties(bool initializePhysicalProps):
    NeuronProperties(initializePhysicalProps),
    refPeriod(2000)
{
}

SpikingNeuronProperties::SpikingNeuronProperties(const SpikingNeuronProperties& rhs):
    NeuronProperties(rhs),
    refPeriod(rhs.refPeriod)
{
}

SpikingNeuronProperties::~SpikingNeuronProperties() {}

void SpikingNeuronProperties::SetProperty(std::string& name, std::string& value)
{
	if (name == "refPeriod") {
		refPeriod = atoi(value.c_str());
	}
	else {
    	NeuronProperties::SetProperty(name, value);
	}
}

std::map< std::string, std::string > SpikingNeuronProperties::GetPropertyMap() const
{
     std::map< std::string, std::string > props = NeuronProperties::GetPropertyMap();
     props["refPeriod"] = ftostr(refPeriod);
     return props;
}
