/***************************************************************************
                          Topology.cpp  -  description
                             -------------------
    copyright            : (C) 2004 by Matt Grover
    email                : mgrover@amygdala.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream>
#include "topology.h"
#include "neuron.h"
#include "axon.h"
#include "network.h"
#include "logging.h"

using namespace Amygdala;
using namespace std;

Topology::Topology(std::string& name):
    NeuronGroup(name)
{
    defaultNrnProps = NULL;
}

Topology::~Topology()
{
}

void Topology::AddNeuron(Neuron* nrn)
{
    NeuronGroup::AddNeuron(nrn);
    InitNewNeuron(nrn);
    Network::GetNetworkRef()->AddNeuron(nrn, this);
}

void Topology::InitNewNeuron(Neuron* nrn)
{
    // nothing to do yet
}

void Topology::SetDefaultNrnProps(const NeuronProperties& neuronProps)
{
}

void Topology::InitRun()
{
	for(unsigned int i=0; i<nrnGroup.size(); ++i) {
		nrnGroup[i]->GetAxon()->BuildNodes();
	}
}
