/***************************************************************************
                          visualstub.h  -  description
                             -------------------
    begin                : Thu Feb 5 2004
    copyright            : (C) 2004 by Rdiger Koch
    email                : rkoch@amygdala.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GLDEBUGGER_H
#define GLDEBUGGER_H

#include <ltdl.h>

namespace Amygdala {

class GenomeHandler;


/** 
  * @brief A stub for the Amygdala Visualizer.
  *
  * Wraps the gory details of loading Visual
  * @author Rudiger Koch
  */

class VisualStub {
public: 
    VisualStub();
    ~VisualStub();

/** Loads the Visual library and initializes it */
    void Init(int & argc, char * argv[]);

/** Run the network in visual mode */
    void RunVisual();

/** Run the morphogenesis in visual mode */
    void RunGA(GenomeHandler * gh);

protected:
    typedef void*(*InitVisualFunc)(int *, char**);
    typedef void (*RunVisualFunc)();
    typedef void (*RunGAFunc)(GenomeHandler*);

    lt_dlhandle visualHandle;
    InitVisualFunc c_InitVisual;
    RunVisualFunc c_RunVisual;
    RunGAFunc c_RunGA;
};

} // namespace Amygdala

#endif

