/***************************************************************************
 *   Copyright (C) 2005 by Rüdiger Koch                                    *
 *   rkoch@rkoch.org                                                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef POLEINPUT_H
#define POLEINPUT_H

#include "amygdala/spikeinput.h"
#include "amygdala/factory.h"
#include "polephysics.h"
#include "poleoutput.h"

namespace Amygdala {
/**
Translates the state of the pole to input spikes

@author Rüdiger Koch
*/
class PoleInput : public Amygdala::SpikeInput {
public:
    typedef SpikeInputFactory<PoleInput> Factory;
    PoleInput();
    PoleInput(const std::string &);

    ~PoleInput();
    virtual void ReadInputBuffer();
    void SetPolePhysics(PolePhysics * pp);
    void SetPoleOutput(PoleOutput * po);

private:
    PolePhysics * polePhysics;
    PoleOutput * poleOutput;
    Amygdala::AmTimeInt nextSchedSpike[6];
};

namespace Factory {
    static PoleInput::Factory MakePoleInput;
}
}
#endif
