/***************************************************************************
 *   Copyright (C) 2005 by Rüdiger Koch                                    *
 *   rkoch@rkoch.org                                                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SPIKEOUTPUTPOLEOUTPUT_H
#define SPIKEOUTPUTPOLEOUTPUT_H

#include "amygdala/spikeoutput.h"
#include <amygdala/factory.h>

namespace Amygdala {
/**
Translates the spiking of output neurons to forces on the pole's slider

@author Rüdiger Koch
*/
class PoleOutput : public Amygdala::SpikeOutput{
public:
    typedef SpikeOutputFactory<PoleOutput> Factory;
    PoleOutput();
    ~PoleOutput();

    void OutputEvent(Amygdala::Neuron *n, Amygdala::AmTimeInt eventTime);
    float GetMotorOutput();
private:
    float force;
};

namespace Factory {
    static PoleOutput::Factory MakePoleOutput;
}
}

#endif
