/***************************************************************************
                          spikeloop.h  -  description
                             -------------------
    begin                : Mon Feb 25 2002
    copyright            : (C) 2002 by Matt Grover
    email                : mpgrover@sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <vector>
#include <amygdala/network.h>
#include <amygdala/feedforwardlayer.h>

class SpikeLoop {
public:
    SpikeLoop(int layerSize, int numLayers);
    ~SpikeLoop();

    void SetSigma(float _sigma) { sigma = _sigma; }
    void BuildNetwork();
protected:
    void NeuronCoordinates(Amygdala::FeedForwardLayer * layer, float x, float y);

    std::vector<Amygdala::FeedForwardLayer*> layers;
    int poolSize;
    unsigned int numLayers;
    float sigma;
};
