/***************************************************************************
                          handler.cpp  -  description
                             -------------------
    begin                : Mon Feb 25 2002
    copyright            : (C) 2002 by Rudiger Koch
    email                : rkoch@rkoch.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <handler.h>
#include <iostream>
#include <stdio.h>
#include <string>

using namespace std;

Handler::Handler(){
    cout << "Instantiating the Handler" << endl;
    geneNo = 0;
    currChromosomeNo = 0;
}
Handler::~Handler(){}

void Handler::Gene (const string & gene, Amygdala::AmIdInt chromosomeId){
    if (chromosomeId != currChromosomeNo) {
        geneNo = 0;
        currChromosomeNo = chromosomeId;
    }
    printf( "Chromosome %2u, gene %2u", chromosomeId, geneNo);
    for(unsigned int i=0; i<gene.length(); i++){
        printf("  %2X", (unsigned char)gene[i]);  // The (unsigned char) cast is always mandatory - else it might be interpreted as 0xFFFFFF4A or so
    }
    cout << endl;
    geneNo++;
}

void Handler::FinishParsing()
{
    cout << "Done parsing, preparing for the morphogenesis" << endl;
}


bool Handler::Step(){
    cout << "\n   .... building up the network\n" << endl;
    return false; // stop right away
}

