/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Mon Feb 25 2002
    copyright            : (C) 2002 by Rudiger Koch
    email                : rkoch@rkoch.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdexcept>
#include <iostream>
#include <string>

#include <tester.h>

#include <amygdala/genome.h>
#include <amygdala/network.h>

using namespace Amygdala;
using namespace std;

void usage(char *cmd)
{
    cout << "\nusage:" << endl;
    cout << "       " << cmd << " [--upload] http://geneserver:port\n" << endl;
    cout << "To connect to http://localhost:10080:" << endl;
    cout << "       " << cmd << "\n" << endl;
    exit(0);
}

void Upload(string url){
    Genome genome(url);

    genome.StartChromosome('c');
    for(unsigned int i=0; i<2; i++)genome.AddGene("abc");
    genome.StartChromosome('v');
    for(unsigned int i=0; i<20; i++)genome.AddGene("AB");
    genome.Upload();
}


int main(int argc, char* argv[]){
    Network::Init(argc, argv);
    string url = "http://localhost:10080";
    if(argc == 2) {
        if(string(argv[1]) == "--help") usage(argv[0]);
        url = argv[argc-1];
    }
    if(argc == 3){
        if(string(argv[1]) == "--upload"){
            try{
                Upload(argv[2]);
            } catch (runtime_error e){
                cerr << "Error caught in main: " << e.what() << endl;
                exit(-1);
            }
        } else {
            usage(argv[0]);
        }
        return 0;
    }
    
    try {
        Tester tester(url);
        tester.Setup();
        tester.Submit();
    } catch (runtime_error e) {
        cout << "Error caught in main: " << e.what() << endl;
    }
    return 0;
}
