/***************************************************************************
                          gene.h  -  description
                             -------------------
    begin                : Sun Nov 25 2001
    copyright            : (C) 2001 by Rudiger Koch
    email                : rkoch@rkoch.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GENE_H
#define GENE_H


#include <string>

/**one gene
  *@author Rudiger Koch
  */

using namespace std;
class Gene {
public:
  /** a copy constructor, sort of - make a gene from a string representation */
  Gene(string gene);
  Gene(int size);
  ~Gene();
  /** flip a random bit in the gene */
  void MutateFlip();
  /** @return the string representation of the gene */
  string GetGene();
  /** used for crossover */
  void SetGene(string _gene);;
  /** Genetic operator: Add or subtract from the number a gene represents */
  void MutatePM();
  /** @return the mutation heat as a float between 0. and 1. */
  float GetMutationHeat();
  /** Mutates the mutation heat. Mutation here means that a fixed amount is added or subtracted. */
  void MutateHeat();

protected: // Protected attributes
    /**  The actual gene */
    string gene;
};

#endif
